<template>
  <div>
    <crumbs title="医学术语静态知识维护">
      <el-form :inline="true" class="demo-form-inline">
        <el-form-item label="术语分类：" class="selectMedicine">
          <el-select size="mini" v-model="filter.libType" placeholder="请选择" clearable>
            <el-option
              v-for="item in typeList"
              :label="item.name"
              :value="item.orderNo"
              :key="item.orderNo"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="标准术语：">
          <el-input size="mini" maxlength="50" v-model="filter.term" placeholder="请输入" clearable></el-input>
        </el-form-item>
        <el-form-item label="状态：" class="selectMedicine">
          <el-select size="mini" v-model="filter.status" placeholder="请选择" clearable>
            <el-option v-for="item in stateList" :label="item.name" :value="item.id" :key="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item class="dododo">
          <el-button size="mini" @click="filterDatas">检索</el-button>
          <el-button
            size="mini"
            type="warning"
            style="margin:0 10px"
            @click="addMedicalPrompt"
          >添加静态知识</el-button>
        </el-form-item>
      </el-form>
    </crumbs>
    <div class="contents">
      <el-table :data="list" border style="width: 100%">
        <el-table-column type="index" :index="indexMethod" label="编号" width="80"></el-table-column>
        <el-table-column prop="gmtModified" label="操作时间" width="180"></el-table-column>
        <el-table-column prop="name" label="标准术语" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column prop="typeName" label="术语分类" width="120"></el-table-column>
        <el-table-column prop="title" label="内容概览" width="240" :show-overflow-tooltip="true"></el-table-column>
        <el-table-column label="状态" width="160">
          <template slot-scope="scope">
            <span v-if="scope.row.status===1">启用</span>
            <span v-if="scope.row.status===0">禁用</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="140">
          <template slot-scope="scope">
            <!-- <el-button v-if="scope.row.status===0" type="text" size="small" class="is-disabled">修改</el-button> -->
            <el-button
              type="text"
              size="small"
              @click="toEditProduct(scope.row)"
            >修改</el-button>
            <!-- <span style="margin:0 3px;">|</span>
                        <el-button v-if="scope.row.isDeleted=='Y' || scope.row.typeId === 82 || scope.row.typeId === 83" type="text" size="small" class="is-disabled">复制</el-button>
            <el-button v-if="scope.row.isDeleted=='N'&&scope.row.typeId !== 82 && scope.row.typeId !== 83" type="text" size="small" @click="toCopyProduct(scope.row)">复制</el-button>-->
            <span style="margin:0 3px;">|</span>
            <el-button
              v-if="scope.row.status===0"
              type="text"
              size="small"
              @click="showReuseDialog(scope.row)"
            >启用</el-button>
            <el-button
              v-if="scope.row.status===1"
              type="text"
              size="small"
              class="delete"
              @click="showDelDialog(scope.row)"
            >禁用</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        :current-page.sync="currentPage"
        @current-change="currentChange"
        background
        :page-size="pageSize"
        class="pagepage pagepage"
        :page-sizes="pageSizeArr"
        @size-change="handleSizeChange"
        :layout="pageLayout"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import api from '@api/icss.js';
import config from '@api/config.js';
import utils from '@api/utils.js';

export default {
  name: 'MedicinePrompt',
  data: function() {
    return {
      list: [],
      cacheData: {},
      currentPage: 1,
      pageSize: config.pageSize,
      pageSizeArr: config.pageSizeArr,
      pageLayout: config.pageLayout,
      total: 0,
      linkIn: [],
      pays: [],
      typeList: [],
      stateList: [
        { id: 1, name: '启用' },
        { id: 0, name: '禁用' }
      ],
      searched: false,
      filter: {
        term: '',
        title: '',
        status: '',
        libType: ''
      }
    };
  },
  created() {
    const param = this.$route.params;
    if(param.currentPage){
      this.inCurrentPage = param.currentPage
    }
    if(param.filter){
      this.filter = param.filter
    }
    //返回时避免参数未赋值就获取列表
    this.$nextTick(()=> {
      // this.clearFilter();
      this.getDataList();
      this.getDicList();
    });
    
    // this.typeList = config.emData;
    // 非首页 编辑页返回 设置 this.currentPage
    // if (Object.keys(this.$route.params).length !== 0) {
    //   this.currentPage = this.$route.params.currentPage;
    // }
  },
  watch: {
    filter: {
      handler: function() {
        this.searched = false;
      },
      deep: true
    }
  },
  // beforeRouteEnter(to, from, next) {
  //   next(vm => {
  //     //const pm = to.param;
  //     Object.assign(vm, to.params);
  //     vm.inCurrentPage = to.params.currentPage;
  //   });
  // },
  methods: {
    // 获取字典类型
    getDicList() {
      api.getDicList().then(res => {
        // console.log(res, '字典类型');
        if (res.data.code === '0') {
          this.typeList = res.data.data && res.data.data['10'];
          // console.log(this.typeList,'this.typeList');
        }
      });
    },

    handleSizeChange(val) {
      this.pageSize = val;
      this.currentPage = utils.getCurrentPage(
        this.currentPage,
        this.total,
        this.pageSize
      );
      this.getDataList();
    },
    addMedicalPrompt() {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({ name: 'AddMedicinePrompt', params: pam });
    },
    toEditProduct(row) {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({
        name: 'AddMedicinePrompt',
        params: Object.assign(pam, { data: row, isEdit: true })
      });
    },
    toCopyProduct(row) {
      const pam = this.searched
        ? {
            currentPage: this.currentPage,
            pageSize: this.pageSize,
            filter: this.filter
          }
        : { currentPage: this.currentPage, pageSize: this.pageSize };
      this.$router.push({
        name: 'AddMedicinePrompt',
        params: Object.assign(pam, { data: row, isCopy: true })
      });
    },
    filterDatas() {
      this.currentPage = 1;
      this.getDataList();
    },
    getDataList(isTurnPage) {
      const param = this.getFilterItems(isTurnPage);
      this.searched = true;
      const loading = this.$loading({
        lock: true,
        text: 'Loading',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });
      api
        .getConceptKnowledgeList(param)
        .then(res => {
          loading.close();
          if (res.data.code == '0') {
            const data = res.data.data;
            // 类型：1-诊断、2-药品、3-检验套餐、4-检验细项、5-检查、6-手术和操作
            /*let temp = [
              '',
              '诊断',
              '药品',
              '检验套餐',
              '检验细项',
              '检查',
              '检查子项',
              '手术和操作',
            ];*/
            this.list = data.records;
            this.cacheData[param.current] = data.records;
            this.total = data.total;
            if (this.inCurrentPage !== undefined) {
              this.currentPage = this.inCurrentPage;
              this.inCurrentPage = undefined;
            }
          }
        })
        .catch(error => {
          if (error.code === '900010001') {
            return false;
          }
          console.log(error);
        });
    },
    clearFilter() {
      this.filter = {
        term: '',
        title: '',
        status: '',
        libType: ''
      };
    },
    getFilterItems(isTurnPage) {
      //翻页时筛选条件没点确定则清空
      if (isTurnPage && !this.searched) {
        this.clearFilter();
      }
      const param = {
        name: this.filter.term.trim(),
        title: this.filter.title,
        current: this.inCurrentPage || this.currentPage,
        size: this.pageSize,
        status: this.filter.status,
        type: this.filter.libType
      };
      return param;
    },
    indexMethod(index) {
      return (this.currentPage - 1) * this.pageSize + index + 1;
    },
    currentChange(next) {
      this.currentPage = next;
      /*if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {*/
      this.getDataList(true);
      //}
    },
    warning(msg, type) {
      this.$message({
        showClose: true,
        message: msg,
        type: type || 'warning'
      });
    },
    showConfirmDialog(msg, resolve, type) {
      let showInfo = '启用';
      let btnNameClass = 'confirmBtn1';
      if (type === 'Del') {
        showInfo = '禁用';
        btnNameClass = 'delBtn';
      }

      this.$confirm(msg, '提示', {
        confirmButtonText: showInfo,
        cancelButtonText: '取消',
        cancelButtonClass: 'cancelBtn',
        confirmButtonClass: btnNameClass,
        type: 'warning'
      })
        .then(() => {
          resolve();
        })
        .catch(() => {});
    },
    showDelDialog(row) {
      this.showConfirmDialog(
        '确定禁用该静态知识？',
        () => {
          api
            .delConceptInfo({ id: row.id, status: 0 })
            .then(res => {
              if (res.data.code == '0') {
                if (!this.searched) {
                  //未点确认时清空搜索条件
                  this.clearFilter();
                }
                this.warning(res.data.msg || '操作成功', 'success');
                this.getDataList();
              } else {
                this.warning(res.data.msg);
              }
            })
            .catch(error => {
              if (error.code === '900010001') {
                return false;
              }
              this.warning(error);
            });
        },
        'Del'
      );
    },
    showReuseDialog(row) {
      this.showConfirmDialog(
        '确定启用该静态知识？',
        () => {
          api
            .delConceptInfo({ id: row.id, status: 1 })
            .then(res => {
              if (res.data.code == '0') {
                this.currentPage = 1; //恢复数据跳转到筛选条件下首页
                this.warning(res.data.msg || '操作成功', 'success');
                this.getDataList();
              } else {
                this.warning(res.data.msg);
              }
            })
            .catch(error => {
              if (error.code === '900010001') {
                return false;
              }
              this.warning(error);
            });
        },
        'Reuse'
      );
    }
  }
};
</script>

<style lang="less">
@import '../../less/admin.less';
.status-span {
  font-size: 12px;
  margin-right: 10px;
  color: unset;
}
.dododo {
  margin-top: 1px !important;
}
.pagepage {
  .el-input.el-input--mini.el-input--suffix input {
    height: 28px;
    line-height: 28px;
  }
  .el-pagination__sizes {
    margin-right: 20px !important;
  }
}
.el-message-box {
  /deep/ .cancelBtn {
    background-color: #d7d7d7;
    border-color: transparent;
  }
  /deep/ .delBtn {
    background-color: #ff545b !important;
    border-color: transparent !important;
  }
  /deep/ .confirmBtn1 {
    position: relative;
    right: 0px !important;
  }
}

.selectMedicine {
  /deep/ .el-input__suffix-inner {
    position: relative;
    top: -1px;
  }
  /deep/ .el-icon-circle-close {
    position: relative;
    top: -2px;
  }
}

body {
  .el-tooltip__popper {
    max-width: 400px;
  }
}

.el-dialog__body {
  overflow-y: auto;
  height: 600px;
}
</style>
